package com.atolcd.web.bean.actions.handlers;

import java.io.Serializable;
import java.text.MessageFormat;
import java.util.Map;

import javax.faces.context.FacesContext;

import org.alfresco.web.app.Application;
import org.alfresco.web.bean.actions.handlers.BaseActionHandler;
import org.alfresco.web.bean.wizard.IWizardBean;

import com.atolcd.repo.action.executer.PDFProtectActionExecuter;

public class PDFProtectActionHandler extends BaseActionHandler {

    private static final long serialVersionUID = 2385236775965776625L;

    public final static String PROP_OWNER_PASSWORD = "owner_password";
    public final static String PROP_USER_PASSWORD = "user_password";
    public final static String PROP_ASSEMBLY = "assembly";
    public final static String PROP_EXTRACT_CONTENT = "extract_content";
    public final static String PROP_EXTRACT_ACCESSIBILITY = "extract_accessibility";
    public final static String PROP_FILLING = "filling";
    public final static String PROP_MODIFY = "modify";
    public final static String PROP_MODIFY_ANNOTATIONS = "modify_annotations";
    public final static String PROP_PRINTING = "printing";
    public final static String PROP_DEGRADED_PRINTING = "degraded_printing";

    public String generateSummary(FacesContext context, IWizardBean wizard,
	    Map<String, Serializable> props) {
	String owner_password = (String) props.get(PROP_OWNER_PASSWORD);
	if (owner_password == null) {
	    owner_password = "";
	}
	String user_password = (String) props.get(PROP_USER_PASSWORD);
	if (user_password == null) {
	    user_password = "";
	}
	Boolean assembly, extractContent, extractContentAccessibility, filling, modify, modifyAnnotations, printing, degradedPrinting;

	assembly = (Boolean) props.get(PROP_ASSEMBLY);
	if (assembly == null) {
	    assembly = false;
	}
	extractContent = (Boolean) props.get(PROP_EXTRACT_CONTENT);
	if (extractContent == null) {
	    extractContent = false;
	}
	extractContentAccessibility = (Boolean) props
		.get(PROP_EXTRACT_ACCESSIBILITY);
	if (extractContentAccessibility == null) {
	    extractContentAccessibility = false;
	}
	filling = (Boolean) props.get(PROP_FILLING);
	if (filling == null) {
	    filling = false;
	}
	modify = (Boolean) props.get(PROP_MODIFY);
	if (modify == null) {
	    modify = false;
	}
	modifyAnnotations = (Boolean) props.get(PROP_MODIFY_ANNOTATIONS);
	if (modifyAnnotations == null) {
	    modifyAnnotations = false;
	}
	printing = (Boolean) props.get(PROP_PRINTING);
	if (printing == null) {
	    printing = false;
	}
	degradedPrinting = (Boolean) props.get(PROP_DEGRADED_PRINTING);
	if (degradedPrinting == null) {
	    degradedPrinting = false;
	}

	return MessageFormat.format(Application.getMessage(context,
		"protect_summary"), new Object[] { assembly, extractContent,
		extractContentAccessibility, filling, modify,
		modifyAnnotations, printing, degradedPrinting });
    }

    public String getJSPPath() {
	return "/jsp/actions/protect.jsp";
    }

    public void prepareForEdit(Map<String, Serializable> props,
	    Map<String, Serializable> repoProps) {
	props.put(PROP_OWNER_PASSWORD, repoProps
		.get(PDFProtectActionExecuter.PARAM_OWNER_PASSWORD));
	props.put(PROP_USER_PASSWORD, repoProps
		.get(PDFProtectActionExecuter.PARAM_USER_PASSWORD));
	props.put(PROP_ASSEMBLY, repoProps
		.get(PDFProtectActionExecuter.PARAM_ASSEMBLY));
	props.put(PROP_EXTRACT_CONTENT, repoProps
		.get(PDFProtectActionExecuter.PARAM_EXTRACT_CONTENT));
	props.put(PROP_EXTRACT_ACCESSIBILITY, repoProps
		.get(PDFProtectActionExecuter.PARAM_EXTRACT_ACCESSIBILITY));
	props.put(PROP_FILLING, repoProps
		.get(PDFProtectActionExecuter.PARAM_FILLING));
	props.put(PROP_MODIFY, repoProps
		.get(PDFProtectActionExecuter.PARAM_MODIFY));
	props.put(PROP_MODIFY_ANNOTATIONS, repoProps
		.get(PDFProtectActionExecuter.PARAM_MODIFY_ANNOTATIONS));
	props.put(PROP_PRINTING, repoProps
		.get(PDFProtectActionExecuter.PARAM_PRINTING));
	props.put(PROP_DEGRADED_PRINTING, repoProps
		.get(PDFProtectActionExecuter.PARAM_DEGRADED_PRINTING));

    }

    public void prepareForSave(Map<String, Serializable> props,
	    Map<String, Serializable> repoProps) {
	repoProps.put(PDFProtectActionExecuter.PARAM_OWNER_PASSWORD, props
		.get(PROP_OWNER_PASSWORD));
	repoProps.put(PDFProtectActionExecuter.PARAM_USER_PASSWORD, props
		.get(PROP_USER_PASSWORD));
	repoProps.put(PDFProtectActionExecuter.PARAM_ASSEMBLY, props
		.get(PROP_ASSEMBLY));
	repoProps.put(PDFProtectActionExecuter.PARAM_EXTRACT_CONTENT, props
		.get(PROP_EXTRACT_CONTENT));
	repoProps.put(PDFProtectActionExecuter.PARAM_EXTRACT_ACCESSIBILITY,
		props.get(PROP_EXTRACT_ACCESSIBILITY));
	repoProps.put(PDFProtectActionExecuter.PARAM_FILLING, props
		.get(PROP_FILLING));
	repoProps.put(PDFProtectActionExecuter.PARAM_MODIFY, props
		.get(PROP_MODIFY));
	repoProps.put(PDFProtectActionExecuter.PARAM_MODIFY_ANNOTATIONS, props
		.get(PROP_MODIFY_ANNOTATIONS));
	repoProps.put(PDFProtectActionExecuter.PARAM_PRINTING, props
		.get(PROP_PRINTING));
	repoProps.put(PDFProtectActionExecuter.PARAM_DEGRADED_PRINTING, props
		.get(PROP_DEGRADED_PRINTING));
    }

}
